package com.brie.dtoo;


import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.apache.wicket.Application;
import org.apache.wicket.Page;
import org.apache.wicket.Request;
import org.apache.wicket.Response;
import org.apache.wicket.Session;
import org.apache.wicket.protocol.http.WebApplication;
import com.brie.dtoo.util.HibernateUtil;



/**
 * Application object for your web application. If you want to run this application without deploying, run the Start class.
 * 
 * @see com.brie.dtoo.Start#main(String[])
 */
public class CheesrApplication extends WebApplication
{    
	
	private List<Cheese> cheeses;

    /**
     * Constructor
     */
	public CheesrApplication()
	{
		org.hibernate.Session myHibSession =  HibernateUtil.getSessionFactory().getCurrentSession();
		myHibSession.beginTransaction();
		cheeses = myHibSession.createQuery("from Cheese").list();
		myHibSession.getTransaction().commit();
		
	}
	
	@Override
	protected void init() {
	}

	
	//@Override
	public Session newSession(Request request, Response response) {
		return new CheesrSession(request);
	}

	
	  /**
	   * Gets the home page for the application.
	   */
	  @Override
	  public Class<? extends Page> getHomePage() {
	    return Index.class;
	  }
	  
	  public static CheesrApplication get() {
		    return (CheesrApplication) Application.get();
		  }

	  public List<Cheese> getCheeses() { 
		  return Collections.unmodifiableList(cheeses); 
	  }
}
